#include <bits/stdc++.h>
using namespace std;

unsigned long long p(long double x1,long double y1,
                     long double x2,long double y2,
                     long double x3,long double y3){
    long double a,b,c,s;
    a = sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
    b = sqrt((x1-x3)*(x1-x3) + (y1-y3)*(y1-y3));
    c = sqrt((x3-x2)*(x3-x2) + (y3-y2)*(y3-y2));
    s = (a+b+c)/2.0;

    long double k1 = sqrt(s);
    long double k2 = sqrt(s-b);
    long double k3 = sqrt(s-c);
    long double k4 = sqrt(s-a);
    unsigned long long k = k1*k2*k3*k4;
    if(k - k1*k2*k3*k4 == 1) return k + 1;
    else return k;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    if(n == 4){
        vector<pair<long double,long double>> vec(4);
        for(int i = 0;i < 4;i++)
            cin >> vec[i].first >> vec[i].second;
        unsigned long long mn = 1000000000000000005;

        for(int i = 0;i < 2;i++)
            for(int j = i+1;j < 3;j++)
                for(int k = j+1;k < 4;k++){
                    long double x1,y1,x2,y2,x3,y3;
                    x1 = vec[i].first; y1 = vec[i].second;
                    x2 = vec[j].first; y2 = vec[j].second;
                    x3 = vec[k].first; y3 = vec[k].second;
                    mn = min(mn,p(x1,y1,x2,y2,x3,y3));
                }

        cout << mn;
    }
}